'
' Demonstration for using the HBusin/HBusout code replacement routines
'
  Include "HBusin.inc"            ' Load the replacement code for the HBusin, HBusout etc commands.
'
' Interface to a 24LC256 serial eeprom
' And display on the serial terminal the results
'
  Dim bLoop As Byte               ' Loading/retrieving loop
  Dim sMyString As String * 10    ' String to hold response
'
' Write bytes to the I2C bus
'
  HRSOut "Writing\r"

  HBStart                         ' Send a Start condition
  HBusOut %10100000               ' Target an eeprom with bus address 0, and send a Write command
  HBusOut 0                       ' Send the High Byte of the address
  HBusOut 0                       ' Send the Low Byte of the address
  For bLoop = "A" To "J"          ' Create a loop containing ASCII A to J
    HRSOut bLoop                  ' Display the character on the serial terminal
    HBusOut bLoop                 ' Write the value of Loop to the eeprom
  Next                            ' Close the loop
  HBStop                          ' Send a Stop condition
  DelayMS 5                       ' Wait for the data to be entered into eeprom matrix
'
' Receive bytes from the I2C bus
'
  Clear sMyString                 ' Clear the string before we start
  HRSOut "\r\rReading\r"

  HBStart                         ' Send a Start condition
  HBusOut %10100000               ' Target an eeprom with bus address 0, and send a Write command
  HBusOut 0                       ' Send the High Byte of the address
  HBusOut 0                       ' Send the Low Byte of the address
  HBReStart                       ' Send a Restart condition
  HBusOut %10100001               ' Target an eeprom with bus address 0, and send a Read command
  For bLoop = 0 To 9              ' Create a loop
    sMyString[bLoop] = HBusIn     ' Load the String with bytes received
    If bLoop = 9 Then             ' Are we at the last byte?
      HBStop                      ' Yes. So send a Stop condition
    Else                          ' Otherwise...
      HBusAck                     ' Send an Ack condition
    EndIf
  Next                            ' Close the loop
  HRSOut sMyString, 13            ' Display the received string on the serial terminal
  Stop

